ExternalEntries (LucidLink Connect)
Present files from external S3 buckets or HTTP URLs directly inside a filespace. These appear as native entries to LucidLink clients.
/api/v1/filespaces/{filespaceId}/external/entries
Create an external entry
Creates an external entry in the filespace. For SingleObjectFile, provide data store ID and object ID. For HttpLinkFile, provide the file URL and, optionally, the ID of an HttpLinkDataStore.
Parameters
Parameter | Type | Description |
|---|---|---|
|
| Required. |
filespaceId
Type
stringDescription
Required.
Request body
Field | Type | Description |
|---|---|---|
|
| Required. Path to the filesystem entry you want to create |
|
| Required. The specific kind of external entry |
|
| The ID of the data store that holds the credentials used to access the cloud object storage. Required when kind is "SingleObjectFile". For "HttpLinkFile": required for filespace format 3.7 and above; must be omitted for 3.6 and below. |
|
| Parameters for creating a single object file. Required when kind is "SingleObjectFile". |
|
| Parameters for creating an HTTP file. Required when kind is "HttpLinkFile". |
path
Type
stringDescription
Required. Path to the filesystem entry you want to create
kind
Type
ExternalEntryKindDescription
Required. The specific kind of external entry
dataStoreId
Type
stringDescription
The ID of the data store that holds the credentials used to access the cloud object storage. Required when kind is "SingleObjectFile". For "HttpLinkFile": required for filespace format 3.7 and above; must be omitted for 3.6 and below.
singleObjectFileParams
Type
SingleObjectFileParamsDtoDescription
Parameters for creating a single object file. Required when kind is "SingleObjectFile".
httpFileParams
Type
HttpFileParamsDtoDescription
Parameters for creating an HTTP file. Required when kind is "HttpLinkFile".
Responses
Status | Description |
|---|---|
| External entry has been successfully created. |
| 1. Paths inside LucidLink should start with a '/'. 2. File system entry already exists. 3. Parent is not a directory. 4. Data store is not configured correctly. 5. Data store credentials are not authorized to access the linked object. 6. Data store ID is invalid. 7. HTTP file URL is not accessible or invalid. 8. This data store type is not supported. 9. A data store must be provided. |
| Invalid or missing credentials. |
| 1. External entries are not supported on this filespace version. 2. External files feature is not configured. 3. External entries are disabled for this filespace. |
| 1. Parent file system entry not found. 2. Data store not found. 3. S3 bucket not found. 4. S3 object not found. |
201
Description
External entry has been successfully created.
400
Description
1. Paths inside LucidLink should start with a '/'. 2. File system entry already exists. 3. Parent is not a directory. 4. Data store is not configured correctly. 5. Data store credentials are not authorized to access the linked object. 6. Data store ID is invalid. 7. HTTP file URL is not accessible or invalid. 8. This data store type is not supported. 9. A data store must be provided.
401
Description
Invalid or missing credentials.
403
Description
1. External entries are not supported on this filespace version. 2. External files feature is not configured. 3. External entries are disabled for this filespace.
404
Description
1. Parent file system entry not found. 2. Data store not found. 3. S3 bucket not found. 4. S3 object not found.
201 response
{"data": {"id": "1234:5678","parentId": "4294967294:0","name": "report.txt","type": "file","size": 1048576,"modifiedAt": "2025-10-21T10:30:00Z","createdAt": "2025-10-20T08:00:00Z"}}
401 response
{"error": {"message": "Invalid or expired token"}}
/api/v1/filespaces/{filespaceId}/external/entries/ids
List external entry IDs by data store
Lists all external entry IDs in the filespace for a given data store. Note: During an active data store rekey, some entries may be skipped.
Parameters
Parameter | Type | Description |
|---|---|---|
|
| Required. ID of the data store to list external entries for |
|
| Maximum number of results to return |
|
| Cursor for pagination |
|
| Required. |
dataStoreId
Type
stringDescription
Required. ID of the data store to list external entries for
limit
Type
numberDescription
Maximum number of results to return
nextCursor
Type
stringDescription
Cursor for pagination
filespaceId
Type
stringDescription
Required.
Responses
Status | Description |
|---|---|
| External entry IDs have been successfully fetched. |
| 1. Data store ID is invalid. 2. limit is out of bounds. 3. nextCursor is invalid. |
| Invalid or missing credentials. |
| 1. External entries are not supported on this filespace version. 2. External files feature is not configured. |
| Data store not found. |
200
Description
External entry IDs have been successfully fetched.
400
Description
1. Data store ID is invalid. 2. limit is out of bounds. 3. nextCursor is invalid.
401
Description
Invalid or missing credentials.
403
Description
1. External entries are not supported on this filespace version. 2. External files feature is not configured.
404
Description
Data store not found.
401 response
{"error": {"message": "Invalid or expired token"}}
404 response
{"error": {"message": "Data store not found"}}
/api/v1/filespaces/{filespaceId}/external/entries/{entryId}
Update an external entry
Updates an existing external entry in the filespace.
Parameters
Parameter | Type | Description |
|---|---|---|
|
| Required. |
|
| Required. |
entryId
Type
stringDescription
Required.
filespaceId
Type
stringDescription
Required.
Request body
Field | Type | Description |
|---|---|---|
|
| Required. Parameters for updating an HTTP file entry |
httpFileParams
Type
HttpFileParamsDtoDescription
Required. Parameters for updating an HTTP file entry
Responses
Status | Description |
|---|---|
| External entry has been successfully updated. |
| 1. File system entry ID is invalid. 2. HTTP file URL is not accessible or invalid. 3. Entry is not an HTTP file. 4. New URL content size does not match the original file size. |
| Invalid or missing credentials. |
| 1. External entries are not supported on this filespace version. 2. External files feature is not configured. 3. External entries are disabled for this filespace. |
| File system entry not found. |
200
Description
External entry has been successfully updated.
400
Description
1. File system entry ID is invalid. 2. HTTP file URL is not accessible or invalid. 3. Entry is not an HTTP file. 4. New URL content size does not match the original file size.
401
Description
Invalid or missing credentials.
403
Description
1. External entries are not supported on this filespace version. 2. External files feature is not configured. 3. External entries are disabled for this filespace.
404
Description
File system entry not found.
200 response
{"data": {"id": "1234:5678","parentId": "4294967294:0","name": "report.txt","type": "file","size": 1048576,"modifiedAt": "2025-10-21T10:30:00Z","createdAt": "2025-10-20T08:00:00Z"}}
401 response
{"error": {"message": "Invalid or expired token"}}
404 response
{"error": {"message": "File system entry not found"}}
/api/v1/filespaces/{filespaceId}/external/entries/{entryId}
Delete an external entry
Deletes an external entry in the filespace, given the entry ID.
Parameters
Parameter | Type | Description |
|---|---|---|
|
| Required. |
|
| Required. |
entryId
Type
stringDescription
Required.
filespaceId
Type
stringDescription
Required.
Responses
Status | Description |
|---|---|
| External entry has been successfully deleted. |
| 1. File system entry ID is invalid. 2. You can only delete external entries from this endpoint. |
| Invalid or missing credentials. |
| File system entry not found. |
200
Description
External entry has been successfully deleted.
400
Description
1. File system entry ID is invalid. 2. You can only delete external entries from this endpoint.
401
Description
Invalid or missing credentials.
404
Description
File system entry not found.
401 response
{"error": {"message": "Invalid or expired token"}}
404 response
{"error": {"message": "File system entry not found"}}